{-# LANGUAGE GADTs #-}
module Functions where

data Image = Image
  deriving (Show)
data ImageConversion = ImageConversion
  deriving (Show)

data Function a b where
  IsImageFilename :: Function FilePath Bool
  ConvertedImageFilename :: Function FilePath FilePath

deriving instance Show (Function a b)

data FunctionIO a b where
  ListDirectory :: FunctionIO FilePath [FilePath]
  OpenImage :: FunctionIO FilePath Image
  ConvertImage :: FunctionIO (Image, ImageConversion) Image
  Save :: FunctionIO (a, FilePath) ()
  RunPandoc :: FunctionIO String String

deriving instance Show (FunctionIO a b)
